blob: b41d49751ce26ca8e61dd56b8a8faa3850612d56 [file] [log] [blame]
Davide Scanob5ade982020-06-03 21:47:13 +02001"""
2 Copyright 2020-present Open Networking Foundation
3
4 Licensed under the Apache License, Version 2.0 (the "License");
5 you may not use this file except in compliance with the License.
6 You may obtain a copy of the License at
7
8 http://www.apache.org/licenses/LICENSE-2.0
9
10 Unless required by applicable law or agreed to in writing, software
11 distributed under the License is distributed on an "AS IS" BASIS,
12 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 See the License for the specific language governing permissions and
14 limitations under the License.
15"""
16
17"""
18 Rules to build the In-band Telemetry (INT) GUI app for GUI 2
19
20
21"""
22
23load("//tools/build/bazel:jdk_genrule.bzl", genrule = "jdk_genrule")
24
25COMPILE_DEPS = CORE_DEPS + JACKSON + KRYO + [
26 "@javax_ws_rs_api//jar",
27 "@servlet_api//jar",
28 "@jetty_websocket//jar",
29 "@jetty_util//jar",
30 "@jersey_media_multipart//jar",
31 "@jersey_server//jar",
32 "//utils/rest:onlab-rest",
33 "//core/store/serializers:onos-core-serializers",
34]
35
36TEST_DEPS = TEST + [
37 "//core/api:onos-api-tests",
38 "//drivers/default:onos-drivers-default",
39]
40
41"""
42 Files that get put at the top level of the tar ball
43"""
44
45filegroup(
46 name = "_root_level_files",
47 srcs =
48 [
49 ":angular.json",
50 ":package.json",
51 ":package-lock.json",
52 ":tsconfig.json",
53 ":tslint.json",
54 ],
55)
56
57filegroup(
58 name = "_e2e_test_files",
59 srcs = [
60 ":e2e/protractor.conf.js",
61 ":e2e/src/app.e2e-spec.ts",
62 ":e2e/src/app.po.ts",
63 ":e2e/tsconfig.e2e.json",
64 ],
65)
66
67"""
68 Run ng build to create INT GUI 2 library in production mode
69 The output file int-gui2-lib-ver.tgz is in the form that can be uploaded directly to https://www.npmjs.com/
70 See bazel-genfiles/apps/inbandtelemetry/int-gui2-lib/int-gui2-lib.log for details of the Angular CLI output
71"""
72
73genrule(
74 name = "int-gui2-lib-build",
75 srcs = [
76 "@nodejs//:bin/npm",
77 "@nodejs//:bin/node",
78 "@nodejs//:bin/nodejs/bin/node",
79 "@nodejs//:bin/nodejs/bin/npm",
80 "//web/gui2-fw-lib:onos-gui2-fw-npm-install",
81 "//web/gui2-fw-lib:onos-gui2-fw-ng-build",
82 "//web/gui2-fw-lib:gui2_fw_lib_ext_css",
83 ":_root_level_files",
84 ":_int_gui2_lib_src",
85 ":_int-gui2_app_files",
86 ],
87 outs = [
88 "int-gui2-lib.log",
89 "int-gui2-lib-ver.tgz",
90 ],
91 cmd = "ROOT=`pwd` &&" +
92 " export HOME=. &&" +
93 " export XDG_CONFIG_HOME=$(@D)/config &&" +
94 " NODE=$(location @nodejs//:bin/node) &&" +
95 " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created
96 " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created
97 " mkdir -p apps/inbandtelemetry/int-gui2-lib &&" +
98 " cd apps/inbandtelemetry/int-gui2-lib &&" +
99 " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" +
100 " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" +
101 " mv package/ node_modules/gui2-fw-lib/ &&" +
102 " mkdir -p projects/int-gui2-lib/fw &&" +
103 " (cd projects/int-gui2-lib/fw &&" +
104 " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" +
105 " chmod +x node_modules/@angular/cli/bin/ng &&" +
106 " export PATH=$$ROOT/$$(dirname $${NODE}):$$ROOT/apps/inbandtelemetry/int-gui2-lib/node_modules/@angular/cli/bin:$$PATH &&" +
107 " ng build --prod int-gui2-lib >> $$ROOT/$(location int-gui2-lib.log) 2>&1 ||" +
108 " if [ $$? -eq 0 ]; then echo 'Successfully ran build';" +
109 " else " +
110 " echo 'Error running \'ng build int-gui2-lib\' on \'//apps/inbandtelemetry/int-gui2-lib:int-gui2-lib-build\'. \\\n" +
111 " See bazel-genfiles/apps/inbandtelemetry/int-gui2-lib/int-gui2-lib.log for more details' >&2;" +
112 #" tail -n 100 ../../$(location onos-gui2-ng-test.log) >&2;" +
113 " exit 1;" +
114 " fi;" +
115 " cd dist/int-gui2-lib && " +
116 " npm pack >> $$ROOT/$(location int-gui2-lib.log) 2>&1 &&" +
117 " mv int-gui2-lib-*.tgz $$ROOT/$(location int-gui2-lib-ver.tgz) &&" +
118 " touch $$ROOT/$(location int-gui2-lib.log)", # to get the log always as the 2nd file,
119 message = "Angular INT GUI2 build",
120 visibility = ["//visibility:public"],
121)
122
123"""
124 Run 'ng test' to run Angular test and 'ng lint' for checkstyle
125 See bazel-genfiles/apps/inbandtelemetry/int-gui2-lib/int-gui2-lib-lint.log or
126 bazel-genfiles/apps/inbandtelemetry/int-gui2-lib/int-gui2-lib-test.log for details of the Angular CLI output
127"""
128
129genrule(
130 name = "_int-gui2-lib-test-genrule",
131 srcs = [
132 "@nodejs//:bin/npm",
133 "@nodejs//:bin/node",
134 "@nodejs//:bin/nodejs/bin/node",
135 "@nodejs//:bin/nodejs/bin/npm",
136 "//web/gui2-fw-lib:onos-gui2-fw-npm-install",
137 "//web/gui2-fw-lib:onos-gui2-fw-ng-build",
138 "//web/gui2-fw-lib:gui2_fw_lib_ext_css",
139 ":_root_level_files",
140 ":_int_gui2_lib_src",
141 ":_int_gui2_lib_src_tests",
142 ],
143 outs = [
144 "int-gui2-lib-ver.log",
145 "int-gui2-lib-lint.log",
146 "int-gui2-lib-test.log",
147 ],
148 cmd = " ROOT=`pwd` &&" +
149 " export HOME=. &&" +
150 " export XDG_CONFIG_HOME=$(@D)/config &&" +
151 " NODE=$(location @nodejs//:bin/node) &&" +
152 " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created
153 " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created
154 " mkdir -p apps/inbandtelemetry/int-gui2-lib &&" +
155 " cd apps/inbandtelemetry/int-gui2-lib &&" +
156 " jar xf ../../../$(location :_int_gui2_lib_src_tests) &&" +
157 " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" +
158 " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" +
159 " mv package/ node_modules/gui2-fw-lib/ &&" +
160 " mkdir -p projects/int-gui2-lib/fw &&" +
161 " (cd projects/int-gui2-lib/fw &&" +
162 " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" +
163 " chmod +x $$ROOT/apps/inbandtelemetry/int-gui2-lib/node_modules/@angular/cli/bin/ng &&" +
164 " export PATH=$$ROOT/$$(dirname $${NODE}):node_modules/@angular/cli/bin:$$PATH &&" +
165 " node -v > ../../../$(location int-gui2-lib-ver.log) &&" +
166 " npm -v >> ../../../$(location int-gui2-lib-ver.log) &&" +
167 " ng -v >> ../../../$(location int-gui2-lib-ver.log) &&" +
168 " echo Lint not run > ../../../$(location int-gui2-lib-lint.log) &&" +
169 " echo Test not run > ../../../$(location int-gui2-lib-test.log) &&" +
170 " exit 0;",
171 # " ng lint int-gui2-lib > ../../../$(location int-gui2-lib-lint.log);" +
172 # " if [ -f /usr/bin/chromium-browser ]; then " + # Add to this for Mac and Chrome
173 # " export CHROME_BIN=/usr/bin/chromium-browser; " +
174 # " elif [ -f /opt/google/chrome/chrome ]; then " +
175 # " export CHROME_BIN=/opt/google/chrome/chrome; " +
176 # " else " +
177 # " MSG='Warning: Step int-gui2-lib-tests skipped because \\n" +
178 # " no binary for ChromeHeadless browser was found at /usr/bin/chromium-browser. \\n" +
179 # " Install Google Chrome or Chromium Browser to allow this step to run.';" +
180 # " echo -e $$MSG >&2;" +
181 # " echo -e $$MSG > ../../../$(location int-gui2-lib-test.log);" +
182 # " exit 0;" +
183 # " fi;" +
184 # " ng test int-gui2-lib --preserve-symlinks --code-coverage --browsers=ChromeHeadless" +
185 # " --watch=false > ../../../$(location int-gui2-lib-test.log) 2>&1 ||" +
186 # " if [ $$? -eq 0 ]; then echo 'Successfully ran tests';" +
187 # " else " +
188 # " echo 'Error running \'ng test int-gui2-lib\' on \'//apps/inbandtelemetry/int-gui2-lib:_int-gui2-lib-test-genrule\'. \\\n" +
189 # " See bazel-genfiles/apps/inbandtelemetry/int-gui2-lib/int-gui2-lib-test.log for more details' >&2;" +
190 # " exit 1;" +
191 # " fi;",
192 message = "Angular INT GUI2 Lib lint and test",
193)
194
195"""
196 Make a group of all the webapp files.
197"""
198
199filegroup(
200 name = "_int_gui2_lib_src",
201 srcs = glob(
202 [
203 "projects/int-gui2-lib/**/*",
204 ],
205 exclude = [
206 "projects/int-gui2-lib/**/*.spec.*", # Don't track tests here
207 "projects/int-gui2-lib/karma.conf.js",
208 "projects/int-gui2-lib/src/test.ts",
209 "projects/int-gui2-lib/fw/**/*",
210 ],
211 ),
212)
213
214"""
215 Make a group of all the webapp qpp files.
216"""
217
218filegroup(
219 name = "_int-gui2_app_files",
220 srcs = glob(
221 [
222 "src/**/*",
223 ],
224 ),
225)
226
227"""
228 Make a jar file of all the webapp test (*.spec.ts) files.
229"""
230
231genrule(
232 name = "_int_gui2_lib_src_tests",
233 srcs = glob(
234 [
235 "projects/int-gui2-lib/karma.conf.js",
236 "projects/int-gui2-lib/src/test.ts",
237 "projects/int-gui2-lib/tsconfig.spec.json",
238 "projects/int-gui2-lib/**/*.spec.ts",
239 ],
240 exclude = [
241 "projects/int-gui2-lib/ng-package.json",
242 "projects/int-gui2-lib/ng-package.prod.json",
243 "projects/int-gui2-lib/package.json",
244 "projects/int-gui2-lib/tsconfig.lib.json",
245 "projects/int-gui2-lib/tslint.json",
246 "projects/int-gui2-lib/src/public_api.ts",
247 ],
248 ),
249 outs = ["int_gui2_lib_src_tests.jar"],
250 cmd = "cd apps/inbandtelemetry/int-gui2-lib &&" +
251 " jar Mcf ../../../$@ .",
252)
253
254"""
255 Make a jar file of all the webapp test (*.spec.ts) files.
256"""
257
258genrule(
259 name = "_int_gui2_lib_tests",
260 srcs = glob(
261 [
262 "projects/int-gui2-lib/**/*.spec.ts",
263 "projects/int-gui2-lib/**/*.spec.json",
264 ],
265 exclude = [
266 "src/main/webapp/tests/**",
267 "src/main/webapp/node_modules/**",
268 "src/main/webapp/dist/**",
269 "src/main/webapp/doc/**",
270 ],
271 ),
272 outs = ["int_gui2_lib_tests.jar"],
273 cmd = "cd apps/inbandtelemetry/int-gui2-lib &&" +
274 " find projects/int-gui2-lib/src/lib -type f -exec touch -t 201808280000 {} \; &&" +
275 " jar Mcf ../../../$@ projects/int-gui2-lib/src/lib",
276)
277
278"""
279 Wrap the genrule for testing in a test
280"""
281
282sh_test(
283 name = "int-gui2-lib-tests",
284 size = "small",
285 srcs = [
286 ":ng-test.sh",
287 ],
288 data = [
289 ":_int-gui2-lib-test-genrule",
290 ],
291 deps = [
292 "@bazel_tools//tools/bash/runfiles",
293 ],
294)